local OnTick = Citizen.CreateThread
local Wait = Citizen.Wait
local SetTimeout = Citizen.SetTimeout
local InvokeNative = Citizen.InvokeNative
local Pressed = IsDisabledControlJustPressed
local Marker = DrawMarker
local points = {}
local vehicle = nil
local cp = 0
local inJob = false
local checkpoint = nil
local street = ""
local cfg = {
    position = vec3(-277.69827270508,281.80752563477,89.887054443359)
}
local blip = vRP.addBlip({cfg.position.x,cfg.position.y,cfg.position.z,620,5,'Electrician',1.0})
RegisterNetEvent('vRP_jobs:StartElectricJob')
AddEventHandler('vRP_jobs:StartElectricJob',function(infoTable)
    local t = 0
    local hash = GetHashKey(infoTable.vehicle)
    local ped = _GPED
    points = infoTable.positions
    if DoesBlipExist(checkPoint) then
        RemoveBlip(checkPoint)
    end

    while not HasModelLoaded(hash) and t < 500 do
        RequestModel(hash)
        Wait(10)
        t = t + 1
    end
    if HasModelLoaded(hash) then
        DoScreenFadeOut(1000)
        Wait(2000)
        vehicle = CreateVehicle(hash,infoTable.vehSpawnPos[1],infoTable.vehSpawnPos[2],infoTable.vehSpawnPos[3],infoTable.vehSpawnPos[4],true,false)
        SetVehicleOnGroundProperly(vehicle)
        SetEntityInvincible(vehicle, false)
        SetPedIntoVehicle(_GPED,vehicle,-1)
        SetVehicleHasBeenOwnedByPlayer(_GPED,true)

        Wait(500)
        DoScreenFadeIn(1000)
        if DoesEntityExist(vehicle) then
            cp = math.random(#points)
            local distance = #(_GCOORDS - points[cp].xyz)
            street = GetStreetNameFromHashKey(GetStreetNameAtCoord(points[cp][1],points[cp][2],points[cp][3]))
            checkPoint = AddBlipForCoord(points[cp][1],points[cp][2],points[cp][3])
            SetBlipSprite(checkPoint, 354)
            SetBlipColour(checkPoint, 81)
            SetBlipRoute(checkPoint, true)
            SetBlipRouteColour(checkPoint, 81)
            SetBlipAsShortRange(checkPoint, true)
            
            vRP.notify({'Du-te pe strada ~g~'..street..'~w~ pentru a repara circuitele!'})
            CreateThread(function()
                inJob = true
                while inJob do
                    if DoesEntityExist(vehicle) then
                        if GetVehicleEngineHealth(vehicle) > 250 then
                            if(GetVehiclePedIsIn(_GPED, false) == vehicle) and (GetPedInVehicleSeat(vehicle, -1) == _GPED) then
                                if distance > 25.0 then
                                    SetTextFont(4)
                                    SetTextProportional(0)
                                    SetTextScale(0.6, 0.6)
                                    SetTextColour(255, 255, 255, 255)
                                    SetTextDropShadow(0, 0, 0, 0, 255)
                                    SetTextEdge(1, 0, 0, 0, 255)
                                    SetTextDropShadow()
                                    SetTextOutline()
                                    SetTextCentre(1)
                                    SetTextEntry("STRING")
                                    AddTextComponentString("DU-TE PE STRADA ~y~"..street:upper().."~w~\nPENTRU A REPARA CIRCUITELE")
                                    DrawText(0.5, 0.825)
                                else
                                    SetTextFont(4)
                                    SetTextProportional(0)
                                    SetTextScale(0.6, 0.6)
                                    SetTextColour(255, 255, 255, 255)
                                    SetTextDropShadow(0, 0, 0, 0, 255)
                                    SetTextEdge(1, 0, 0, 0, 255)
                                    SetTextDropShadow()
                                    SetTextOutline()
                                    SetTextCentre(1)
                                    SetTextEntry("STRING")
                                    AddTextComponentString("COBOARA DIN MASINA PENTRU A REPARA CIRCUITELE")
                                    DrawText(0.5, 0.825)
                                end
                            else
                                if distance > 25.0 then
                                    local ticks = GetGameTimer() + 60000
                                    while (GetGameTimer() < ticks) and (DoesEntityExist(vehicle)) and (distance > 25.0) and (GetVehiclePedIsIn(_GPED, false) ~= vehicle) do
                                        timer = math.floor(((ticks - GetGameTimer()) / 1000))
                                        SetTextFont(4)
                                        SetTextProportional(0)
                                        SetTextScale(0.6, 0.6)
                                        SetTextColour(255, 255, 255, 255)
                                        SetTextDropShadow(0, 0, 0, 0, 255)
                                        SetTextEdge(1, 0, 0, 0, 255)
                                        SetTextDropShadow()
                                        SetTextOutline()
                                        SetTextCentre(1)
                                        SetTextEntry("STRING")
                                        AddTextComponentString("~r~INTOARCE-TE INAPOI IN DUBITA!\n~g~"..timer.."~w~ secunde ramase")
                                        DrawText(0.5, 0.825)
                                        Wait(1)
                                    end
                                    if (GetVehiclePedIsIn(_GPED, false) ~= vehicle) then
                                        vRP.notify({"~r~Nu te-ai intors la timp in dubita! Ai fost concediat."})
                                        TriggerServerEvent('vRP_jobs:EndElectricJob')
                                        inJob = false
                                        if DoesBlipExist(checkPoint) then
                                            RemoveBlip(checkPoint)
                                        end
                                        break
                                    end
                                end
                            end
                        else
                            inJob = false
                            vRP.notify({"~r~Dubita a fost distrusa! Ai fost concediat."})
                            TriggerServerEvent('vRP_jobs:EndElectricJob')
                            if DoesBlipExist(checkPoint) then
                                RemoveBlip(checkPoint)
                            end
                            break
                        end
                        if distance < 25.0 then
                            if (distance > 2.5) and (tonumber(GetVehiclePedIsIn(_GPED, false)) == 0) then
                                SetTextFont(4)
                                SetTextProportional(0)
                                SetTextScale(0.6, 0.6)
                                SetTextColour(255, 255, 255, 255)
                                SetTextDropShadow(0, 0, 0, 0, 255)
                                SetTextEdge(1, 0, 0, 0, 255)
                                SetTextDropShadow()
                                SetTextOutline()
                                SetTextCentre(1)
                                SetTextEntry("STRING")
                                AddTextComponentString("Du-te la panoul electric\npentru a repara circuitele")
                                DrawText(0.5, 0.825)
                            elseif (distance <= 2.5) and (tonumber(GetVehiclePedIsIn(_GPED, false)) == 0) then
                                DrawAdvanced3DText(points[cp][1],points[cp][2],points[cp][3] + 0.7, '~w~Apasa tasta ~r~E~w~ pentru a repara circuitele', 1.0,0,245,198,152,150)
                                if Pressed(0,38) then
                                    StartScreenEffect("MenuMGTournamentIn", 0, true)
                                    SetEntityHeading(_GPED,points[cp][4])
                                    SetNuiFocus(true,true)
                                    SendNUIMessage({
                                        act = 'show',
                                        menu = "job_electric_game",
                                        job = 'electrician'
                                    })
                                end
                            end
                            Marker(1,points[cp][1],points[cp][2],points[cp][3]-1.3,0,0,0,0,0,0,1.0,1.0,1.0,255,0,0,220,0,0,0,0)
                        end
                    else
                        inJob = false
                        vRP.notify({"~r~Dubita a fost distrusa! Ai fost concediat."})
                        TriggerServerEvent('vRP_jobs:EndElectricJob')
                        if DoesBlipExist(checkPoint) then
                            RemoveBlip(checkPoint)
                        end
                        break
                    end
                    Wait(1)
                    distance = #(_GCOORDS - points[cp].xyz)
                end
            end)
        end
    end
end)
OnTick(function()
	local ticks = 500
	while true do
		if #(_GCOORDS - cfg.position) < 20.0 then
			if not inJob then
				ticks = 1
				DrawAdvanced3DText(cfg.position.x,cfg.position.y,cfg.position.z + 1.0, '~w~Job ~HUD_COLOUR_GOLF_P2~Electrician', 1.0,0,200,30,0,255) 
				DrawAdvanced3DText(cfg.position.x,cfg.position.y,cfg.position.z + 0.7, '~w~Apasa tasta ~r~E~w~ pentru a incepe sa muncesti', 1.0,0,245,198,152,150) 
				if #(_GCOORDS - cfg.position) < 10.0 then
					if Pressed(0,38) then
                        Wait(300)
                        TriggerServerEvent('vRP_jobs:StartElectricJob')
					end
				end
			else
				ticks = 500
			end
		end
		Wait(ticks)
	end
end)

RegisterNUICallback("cb_electric", function(data, cb)
    local d = data.event
    if d == "pay" then
        SetNuiFocus(false,false)
        SendNUIMessage({
            act = 'hide',
            menu = "job_electric_game"
        })
        StopScreenEffect("MenuMGTournamentIn")
        StartScreenEffect("MenuMGHeistOut", 800, false)
        TriggerServerEvent('vRP_jobs:getElectricianMoney',cp)
        cp = math.random(#points)
        if DoesBlipExist(checkPoint) then
            RemoveBlip(checkPoint)
            checkPoint = nil
        end

        street = GetStreetNameFromHashKey(GetStreetNameAtCoord(points[cp][1],points[cp][2],points[cp][3]))
        checkPoint = AddBlipForCoord(points[cp][1],points[cp][2],points[cp][3])
        SetBlipSprite(checkPoint, 354)
        SetBlipColour(checkPoint, 81)
        SetBlipRoute(checkPoint, true)
        SetBlipRouteColour(checkPoint, 81)
        SetBlipAsShortRange(checkPoint, true)
        
        vRP.notify({'Du-te pe strada ~g~'..street..'~w~ pentru a repara circuitele!'})
    elseif d == "tryAgain" then
        SetNuiFocus(false,false)
        SendNUIMessage({
            act = 'hide',
            menu = "job_electric_game"
        })
        vRP.notify({"~r~Ai conectat firele gresit!"})
        StopScreenEffect("MenuMGTournamentIn")
        StartScreenEffect("MenuMGHeistOut", 800, false)
        SetPedToRagdoll(_GPED, 500, 500, 0, 0, 0, 0)
        ShakeGameplayCam("VIBRATE_SHAKE", 1.0)
        Wait(2500)
        SetTimecycleModifier("")
        SetTransitionTimecycleModifier("")
        StopGameplayCamShaking()
    end
end)